<?php

   $cYear = date("Y");

// -------------------------------------------------------------
// Set the path to the program to be executed when the submit
// button is clicked.  In this case, it is this program itself.
// It modifies itself each time it is called.

   $RunThisProgram = $_SERVER["SCRIPT_NAME"];

// -------------------------------------------------------------
// Read input arguments from interface.

   $Y = trim(@$_POST["y"]);  if ($Y == '') {$Y = date("Y");}

   if (@$_POST["minus_button"] != '') {$Y--;}
   if (@$_POST["plus_button"]  != '') {$Y++;}

   $TZSign = trim(@$_POST["TZSign"]);

   if ($TZSign ==  '') {$TZSign = "-";}
   if ($TZSign != '-') {$TZSign = '+';}

   $TZhh = trim(@$_POST["TZhh"]);  if ($TZhh == '') {$TZhh = "05";}
   $TZmm = trim(@$_POST["TZmm"]);  if ($TZmm == '') {$TZmm = "00";}

   $TZhh = sprintf("%02d", $TZhh);
   $TZmm = sprintf("%02d", $TZmm);

   $TZhhmm = "$TZSign$TZhh:$TZmm";

// Define "... COMPUTING ..." message to be displayed via JavaScript when any button is clicked.
   $computing = "working.innerHTML='<div style=\'color:red; text-align:center; font-size:150%; font-weight:bold;\'>&#183;&#183;&#183; COMPUTING &#183;&#183;&#183;</div>';";

   if ($Y < 1600 or $Y > 2200)
  {
   $out = "<b>ERROR: Year must be in the range from 1600 to 2200.</b>";
  }
   else
  {

// Compute Equinoxes and solstices table in TT
// and in local standard times for comparison.

// For TT time scale.  No adjustment for Delta T.
   $a1 = Mar_Equinox_Stats  ($Y, "+00:00", FALSE);
   $b1 = Jun_Solstice_Stats ($Y, "+00:00", FALSE);
   $c1 = Sep_Equinox_Stats  ($Y, "+00:00", FALSE);
   $d1 = Dec_Solstice_Stats ($Y, "+00:00", FALSE);

// For local standard times and UT adjusted for Delta T
   $w  = Mar_Equinox_Stats  ($Y, $TZhhmm);
   $a2 = substr($w, 19, strlen($w));
   $w  = Jun_Solstice_Stats ($Y, $TZhhmm);
   $b2 = substr($w, 19, strlen($w));
   $w = Sep_Equinox_Stats  ($Y, $TZhhmm);
   $c2 = substr($w, 19, strlen($w));
   $w = Dec_Solstice_Stats ($Y, $TZhhmm);
   $d2 = substr($w, 19, strlen($w));

   $LTorUT = ($TZhh == "00" and $TZmm = "00")? "UT":"Loc Std Time";


$out =
"
<pre style='font-family:monospace;'>
Dates and Local Standard Times of the Equinoxes and Solstices For Year $Y
Local Time Zone Offset UT$TZhhmm

============================================================================
      Event          Julian Date TT       Date     Time    DoW   Time Scale
=================   ================   =========== =====   ===  ============
March Equinox       $a1  TT
                                       $a2  $LTorUT

June Solstice       $b1  TT
                                       $b2  $LTorUT

September Equinox   $c1  TT
                                       $c2  $LTorUT

December Solstice   $d1  TT
                                       $d2  $LTorUT

============================================================================
NOTE:

To adjust for daylight saving/summer time, add 1 hour to the local standard
times, being careful to watch for a possible change of date while doing so.
</pre>
";

 $out = Str_Replace(' = ', '   ', $out);

  }







/*
   ---------------------------------------------------------
   This function computes the date and time of the March
   equinox for any given year and time zone, based on the
   NASA/JPL DE405 ephemeris and the NASA polynomials for
   Delta T estimation.

   The equinoxes are the dates on which the days and nights
   around the world are most closely equal in length than
   on any other dates of the year.  They also mark the
   beginnings of spring and autumn.

   Here, the equinox is defined as the moment when the
   geocentric sun is centered on the celestial equator
   crossing it from south to north.  At these moments,
   the declination of the Sun is at zero degrees.

   ---------------------------------------------------------
   Y      = Year (1600 to 2200)
   TZhhmm = Standard time zone offset (�hh:mm)
            Local Standard Time = UT + TZhhmm

   dTFlag = Delta T flag.
            TRUE=ON = Apply Delta T to time = Default
            FALSE=OFF = Do NOT apply Delta T to time.

   ERRORS:
   FALSE is returned year is outside range 1600 to 2200.
   ---------------------------------------------------------
*/

   function Mar_Equinox_Stats ($Y, $TZhhmm="+00:00", $dTFlag=TRUE)
{
// ERROR if year out of range from 1600 to 2200.
   if ($Y < 1600 or $Y > 2200) {return FALSE;}

// Read Sun coordinates data file into working array.
   $DataFileLines = file("data/geocen_equ_Sun_coords_1600_to_2200.data");
   $DataFileLinesCount = count($DataFileLines);

// Compute JD12TT for Mar 15th of given year and
// find data table array index (i) for it.
   $JD12TTStart = intval(Date_Time_TZ_to_JDTT($Y . "0315 12:00 +00:00", FALSE));

   for ($i=0;   $i < $DataFileLinesCount;   $i++)
   {
    $DataLine = trim($DataFileLines[$i]);

    if(substr($DataLine,0,7) == $JD12TTStart) {break;}
   }

// Starting on Mar 15th, search forward for date where the
// numerical sign of the declination changes from negative
// to positive. This will be used to determine the center
// date for a 7-point LaGrange interpolation table.
   for ($i=$i;   $i < $DataFileLinesCount;   $i++)
       {
        $DataLine = trim($DataFileLines[$i]);

        if(strpos($DataLine,"+") !== FALSE) {break;}
       }

// Construct 7-day interpolation
// table of DeclDeg vs JD12TT.
   $DataTable = "";

   for ($j = $i-4;   $j <= $i+2;   $j++)
       {
        $DataLine   = trim($DataFileLines[$j]);
        $JD12TT     = substr($DataLine,0,7);
        $DeclDeg    = sprintf("%+1.6f", substr($DataLine,16,9)/1E6);
        $DataTable .= "$DeclDeg $JD12TT\n";
       }

// Interpolate JDTT value within DataTable
// where DeclDeg = 0 degrees.
   $JDTTEvent = Lagrange_Interp($DataTable, 0);
   $JDTTEvent = sprintf("%1.8f", $JDTTEvent);

// Convert TT of event into local date/time/TZ.
   $Date_Time_TZ = JDTT_TZ_to_Date_Time("$JDTTEvent $TZhhmm", $dTFlag);

// Determine local DoWStr (Day of the Week).
// The local DoW could differ from the TT DoW.
   $w = substr($Date_Time_TZ, 0,8) . " 12:00 +00:00";
   $wJD12 = intval(Date_Time_TZ_to_JDTT($w, FALSE));
   $DoWStr = substr("SunMonTueWedThuFriSat", 3*((floor($wJD12 + 0.5) + 1) % 7), 3);

// Construct output statistics string.
   $DateString = "$Y-Mar-" . substr($Date_Time_TZ, 6, strlen($Date_Time_TZ));

// Cut out TZ part of date string.
   $DateString = substr($DateString, 0,20) . substr($DateString, 22+6,strlen($DateString));

// Done.
   return "$JDTTEvent = $DateString$DoWStr";

} // End of  Mar_Equinox_Stats(...)



/*
   -------------------------------------------------------------------
   This function computes the date and time of the
   June solstice for any given year and time zone,
   based on the NASA/JPL DE405 ephemeris and the
   NASA polynomials for Delta T.

   Here, the June solstice is defined as the moment
   that the sun is at right ascension 90 degrees or
   6 hours on the celestial sphere.

   The solstices mark the beginning of the summer
   and winter seasons.

   ---------------------------------------------------------
   Y      = Year (1600 to 2200)
   TZhhmm = Standard time zone offset (�hh:mm)
            Local Standard Time = UT + TZhhmm

   dTFlag = Delta T flag.
            TRUE=ON = Apply Delta T to time = Default
            FALSE=OFF = Do NOT apply Delta T to time.

   ERRORS:
   FALSE is returned year is outside range 1600 to 2200.
   ---------------------------------------------------------*/

   function Jun_Solstice_Stats($Y, $TZhhmm="+00:00", $dTFlag=TRUE)
{
// Read Sun coordinates data file into working array.
   $DataFileLines = file("data/geocen_equ_Sun_coords_1600_to_2200.data");
   $DataFileLinesCount = count($DataFileLines);

// Compute JD12TT for Jun 15th of given year and
// find data table array index (i) for it.
   $JD12TTStart = intval(Date_Time_TZ_to_JDTT($Y . "0615 12:00 +00:00", FALSE));

   for ($i=0;   $i < $DataFileLinesCount;   $i++)
   {
    $DataLine = trim($DataFileLines[$i]);

    if(substr($DataLine,0,7) == $JD12TTStart) {break;}
   }

// Starting on Jun 15th, search forward for date where the
// geocentric RA of the sun is 06h (90 degrees).  This will
// be used to determine the center date for a 7-point
// LaGrange interpolation table.
   for ($i=$i;   $i < $DataFileLinesCount;   $i++)
       {
        $DataLine = trim($DataFileLines[$i]);
        $RAHrs = sprintf("%1.7f", substr($DataLine,7,9)/1E7);
        if ($RAHrs >= 6) {break;}
       }

// Construct 7-day interpolation
// table of RAHrs vs JD12TT.
   $DataTable = '';

   for ($j = $i-3;   $j <= $i+3;   $j++)
       {
        $DataLine = trim($DataFileLines[$j]);
        $JD12TT = substr($DataLine,0,7);
        $RAHrs = sprintf("%1.7f", substr($DataLine,7,9)/1E7);
        $DataTable .= "$RAHrs $JD12TT\n";
       }

// Interpolate JDTT value within
// DataTable where RAHrs == 6
   $JDTTEvent = Lagrange_Interp($DataTable, 6);
   $JDTTEvent = sprintf("%1.8f", $JDTTEvent);

// Convert TT of event into local date/time/TZ.
   $Date_Time_TZ = JDTT_TZ_to_Date_Time("$JDTTEvent $TZhhmm", $dTFlag);

// Determine local DoWStr (Day of the Week).
// This could differ from the TT DoW.
   $w = substr($Date_Time_TZ, 0, 8) . " 12:00 +00:00";
   $wJD12 = intval(Date_Time_TZ_to_JDTT($w, FALSE));
   $DoWStr = substr("SunMonTueWedThuFriSat", 3*((floor($wJD12 + 0.5) + 1) % 7), 3);

// Construct output statistics string.
   $DateString = "$Y-Jun-" . substr($Date_Time_TZ, 6, strlen($Date_Time_TZ));

// Cut out TZ part of date string.
   $DateString = substr($DateString, 0,20) . substr($DateString, 22+6,strlen($DateString));

// Done.
   return "$JDTTEvent = $DateString$DoWStr";

} // End of  Jun_Solstice_Stats(...)



/*
   -------------------------------------------------------------------
   This function computes the date and time of the
   September equinox for any given year and time
   zone, based on the NASA/JPL DE405 ephemeris
   and the NASA polynomials for Delta T.

   Here, the equinox is defined as the moment that
   the sun is centered on the celestial equator as
   is crosses it from north to south.

   The equinoxes are the dates on which the days and
   nights around the world are most closely equal in
   length than on any other dates of the year. There
   are two equinoxes each year, one in March and the
   other in September.

   ---------------------------------------------------------
   Y      = Year (1600 to 2200)
   TZhhmm = Standard time zone offset (�hh:mm)
            Local Standard Time = UT + TZhhmm

   dTFlag = Delta T flag.
            TRUE=ON = Apply Delta T to time = Default
            FALSE=OFF = Do NOT apply Delta T to time.

   ERRORS:
   FALSE is returned year is outside range 1600 to 2200.
   ---------------------------------------------------------
*/

   function Sep_Equinox_Stats($Y, $TZhhmm="+00:00", $dTFlag=TRUE)
{
// Read Sun coordinates data file into working array.
   $DataFileLines = file("data/geocen_equ_Sun_coords_1600_to_2200.data");
   $DataFileLinesCount = count($DataFileLines);

// Compute JD12TT for Sep 15th of given year and
// find data table array index (i) for it.
   $JD12TTStart = intval(Date_Time_TZ_to_JDTT($Y . "0915 12:00 +00:00", FALSE));

   for ($i=0;   $i < $DataFileLinesCount;   $i++)
   {
    $DataLine = trim($DataFileLines[$i]);

    if(substr($DataLine,0,7) == $JD12TTStart) {break;}
   }

// Starting on Sep 15th, search forward for date where the
// numerical sign of the declination changes from positive
// to negative. This will be used to determine the center
// date for a 7-point LaGrange interpolation table.
   for ($i=$i;   $i < $DataFileLinesCount;   $i++)
       {
        $DataLine = trim($DataFileLines[$i]);

        if(strpos($DataLine,"-") !== FALSE) {break;}
       }

// Construct 7-day interpolation
// table of DeclDeg vs JD12TT.
   $DataTable = "";

   for ($j = $i-4;   $j <= $i+2;   $j++)
       {
        $DataLine = trim($DataFileLines[$j]);
        $JD12TT = substr($DataLine,0,7);
        $DeclDeg = sprintf("%+1.6f", substr($DataLine,16,9)/1E6);

        $DataTable .= "$DeclDeg $JD12TT\n";
       }

// Interpolate JDTT value within DataTable
// where DeclDeg = 0 degrees.
   $JDTTEvent = Lagrange_Interp($DataTable, 0);
   $JDTTEvent = sprintf("%1.8f", $JDTTEvent);

// Convert TT of event into local date/time/TZ.
   $Date_Time_TZ = JDTT_TZ_to_Date_Time("$JDTTEvent $TZhhmm", $dTFlag);

// Determine local DoWStr (Day of the Week).
// This could differ from the TT DoW.
   $w = substr($Date_Time_TZ, 0,8) . " 12";
   $wJD12 = intval(Date_Time_TZ_to_JDTT($w, FALSE));
   $DoWStr = substr("SunMonTueWedThuFriSat", 3*((floor($wJD12 + 0.5) + 1) % 7), 3);

// Construct output statistics string.
   $DateString = "$Y-Sep-" . substr($Date_Time_TZ, 6, strlen($Date_Time_TZ));

// Cut out TZ part of date string.
   $DateString = substr($DateString, 0,20) . substr($DateString, 22+6,strlen($DateString));

// Done.
   return "$JDTTEvent = $DateString$DoWStr";

}  // End of Sep_Equinox_Stats(...)




/*
   -------------------------------------------------------------------
   This function computes the date and time of the December solstice
   for any given year and time zone, based on the NASA/JPL DE405
   ephemeris and the NASA polynomials for Delta T.

   The solstices mark the beginnings of the summer and winter seasons.

   Here, the December solstice is defined as the moment when the sun
   is at geocentric right ascension 18 hours on the celestial sphere.

   ---------------------------------------------------------
   Y      = Year (1600 to 2200)
   TZhhmm = Standard time zone offset (�hh:mm)
            Local Standard Time = UT + TZhhmm

   dTFlag = Delta T flag.
            TRUE=ON = Apply Delta T to time = Default
            FALSE=OFF = Do NOT apply Delta T to time.

   ERRORS:
   FALSE is returned year is outside range 1600 to 2200.
   ---------------------------------------------------------
*/

   function Dec_Solstice_Stats($Y, $TZhhmm="+00:00", $dTFlag=TRUE)
{
// Read Sun coordinates data file into working array.
   $DataFileLines = file("data/geocen_equ_Sun_coords_1600_to_2200.data");
   $DataFileLinesCount = count($DataFileLines);

// Compute JD12TT for Dec 15th of given year and
// find data table array index (i) for it.
   $JD12TTStart = intval(Date_Time_TZ_to_JDTT($Y . "1215 12:00 +00:00", FALSE));

   for ($i=0;   $i < $DataFileLinesCount;   $i++)
   {
    $DataLine = trim($DataFileLines[$i]);

    if(substr($DataLine,0,7) == $JD12TTStart) {break;}
   }

// Starting on Dec 15th, search forward for date where the
// geocentric RA of the sun is 18h. This will be used to
// determine the center date for a 7-point LaGrange
// interpolation table.
   for ($i=$i;   $i < $DataFileLinesCount;   $i++)
       {
        $DataLine = trim($DataFileLines[$i]);
        $RAHrs = sprintf("%1.7f", substr($DataLine,7,9)/1E7);
        if ($RAHrs >= 18) {break;}
       }

// Construct 7-day interpolation
// table of RAHrs vs JD12TT.
   $DataTable = "";

   for ($j = $i-3;   $j <= $i+3;   $j++)
       {
        $DataLine = trim($DataFileLines[$j]);
        $JD12TT = substr($DataLine,0,7);
        $RAHrs = sprintf("%1.7f", substr($DataLine,7,9)/1E7);
        $DataTable .= "$RAHrs $JD12TT\n";
       }

// Interpolate JDTT value within DataTable
// where RAHrs = 18 hours.
   $JDTTEvent = Lagrange_Interp($DataTable, 18);
   $JDTTEvent = sprintf("%1.8f", $JDTTEvent);

// Convert TT of event into local date/time/TZ.
   $Date_Time_TZ = JDTT_TZ_to_Date_Time("$JDTTEvent $TZhhmm", $dTFlag);

// Determine local DoWStr (Day of the Week).
// This could possibly differ from the TT DoW.
   $w = substr($Date_Time_TZ, 0,8) . " 12:00 +00:00";
   $wJD12 = intval(Date_Time_TZ_to_JDTT($w, FALSE));
   $DoWStr = substr("SunMonTueWedThuFriSat", 3*((floor($wJD12 + 0.5) + 1) % 7), 3);

// Construct output statistics string.
   $DateString = "$Y-Dec-" . substr($Date_Time_TZ, 6, strlen($Date_Time_TZ));

// Cut out TZ part of date string.
   $DateString = substr($DateString, 0,20) . substr($DateString, 22+6,strlen($DateString));

// Done.
   return "$JDTTEvent = $DateString$DoWStr";

} // End of  Dec_Solstice_Stats(...)




// Generate the HTML page to display the computations.

print <<< _HTML

<!DOCTYPE HTML>

<html lang='en'>

<head>

<title>Solstices and Equinoxes Calculator</title>
<meta name='viewport' content='width=device-width, initial-scale=1'>
<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<meta name='description' content='Solstices and Equinoxes Calculator'>
<meta name='keywords' content='solstices,equinoxes,seasons'>
<meta name='author' content='Jay Tanner - PHPScienceLabs.com'>
<meta http-equiv='pragma'  content='no-cache'>
<meta http-equiv='expires' content='-1'>
<meta name='robots'    content='index,follow'>
<meta name='googlebot' content='index,follow'>
<link rel="canonical" href="https://www.phpsciencelabs.com/earth-solstices-and-equinoxes-calculator/">

<style>

body {
      background:black; color:white: font-family:Verdana; font-size:105%;
      line-height:145%;
     }

div {
     background:white; color:black; font-family:Verdana; font-size:105%;
     line-height:145%; padding:6px;
    }

pre {
     background:white; color:black; font-family:monospace; font-size:150%;
     font-weight:bold; text-align:left; padding:6px;
    }

code {
      font-family:monospace; font-size:150%; font-weight:bold;
      color:black; background:LightYellow; padding:2px;
     }

hr {background:black; height:2px; border:0px;}

td {
    background:white; color:black; font-family:Verdana; text-align:left;
    padding:8px;
   }

img {
     border:1px solid #808080; box-shadow:4px 4px 3px #999999;
     border-radius:8px;
    }

input[type='text']::-ms-clear {width:0; height:0;}

 input[type='text']
{
 color:black; background:white; font-family:monospace;
 font-size:175%; font-weight:bold; text-align:center;
 border-radius:4px;
}

 input[type='text']:focus
{
 color:black; background:white;
 font-family:monospace; font-size:175%; font-weight:bold;
 text-align:center; border:2px solid blue; border-radius:4px;
}

 input[type='submit']
{
 font-weight:bold; border-radius:4px;
 border:1px solid black; font-size:120%;
}

 input[type='submit']:hover
{
 box-shadow:2px 2px 2px #444444; background:cyan;
 font-weight:bold; border-radius:4px;
}

 textarea
{
 background:white; color:black; font-size:150%; font-family:monospace;
 font-weight:bold; border-radius: 8px; border:2px solid blue; padding:6px;
 word-wrap: break-word;
}

 A:link
{
 background:transparent; color:blue; font-size:90%; font-family:Verdana;
 font-weight:bold; text-decoration:none; line-height:175%; padding:2px;
 border:1px solid transparent;
}

A:visited {background:transparent; color:blue; font-size:90%;}

 A:hover
{
 background:yellow; color:black; font-size:90%; border:1px solid black;
 box-shadow:1px 1px 3px #222222;
}

A:active {background:yellow; color:black; font-size:90%;}

::selection      {background:yellow; color:black;}  /* For IE9+ and Safari     */
::-moz-selection {background:yellow; color:black;}  /* For FireFox and Mozilla */

</style>

</head>



<body style='font-family:Verdana; font-size:80%; color:white; background:black;'>

<table width="745" align="left" bgcolor='black'>

<tr><td style='color:white; font-size:125%; background-color:#000044; text-align:center; padding:4px;  border:2px solid white;border-radius:8px 8px 0px 0px;'><b>Local Dates and Times of the Solstices and Equinoxes<br>For Any Gregorian Year From 1600 to 2200 and Local Time Zone<br><span style='font-size:70%;'>PHP Program by Jay Tanner</span>
</b><br><br><span style='font-size:80%;'>Based on the NASA/JPL DE405 Ephemeris Model and the NASA Polynomials For Delta T</span></td></tr>

<tr><td align="left" style='color:white; background:white; text-align:center; border:thin solid black; padding:2px;'>
<div style='font-size:100%; color:white; background-color:black; border:thin solid black; padding:2px;'>
<form  name="form1" method="post" action="$RunThisProgram">
<b>Gregorian Year</b> (1600 to 2200) &nbsp; <input name="y" type="text" value="$Y" size='5' maxlength='4'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>Local&nbsp;Time&nbsp;Zone&nbsp;Offset:&nbsp;UT</b>

<input name="TZSign" type="text" value="$TZSign" size='1' maxlength='1'>

<input name="TZhh" type="text" value="$TZhh" size='3' maxlength='2'><b>:</b><input name="TZmm" type="text" value="$TZmm" size='3' maxlength='2'>&nbsp;&nbsp;&nbsp;
<input name="compute_button" type="submit" value="Compute" OnClick="$computing">
<input name="minus_button"   type="submit" value="&minus;" title='-1 Year Backward' OnClick="$computing">
<input name="plus_button"    type="submit" value="+" title='+1 Year Forward' OnClick="$computing">
</form>
</div>

 <div ID = "working" style='color:black; background-color:white; text-align:left; padding:4px; font-size:125%;'>
 $out
</div>

</td></tr>





<tr><td>
<br>
<div style='font-size:130%; text-align:center;'><b>Definitions of the Solstices and Equinoxes Used Here</b></div>

<div style='font-size:120%; text-align:center;'>
The dates and times of the <b style='color:blue;'>Northern</b><b>/</b><b style='color:red;'>Southern</b> solstices and equinoxes<br>are computed according to the following definitions:</div>

<div style='font-size:125%; text-align:justify;'>
The <b>solstices</b> refer to that point in the sky where the sun appears to reach its highest or lowest midday elevation in the sky and where it appears to hover for a day or so before slowing starting to move back in the opposite direction, southward or northward, depending on the season, a little more each day.&nbsp; There are two such solstices each year and they mark the dates on which the summer and winter seasons begin.
<br><br>
The <b>equinoxes</b> refer to those dates of the year where the days and nights throughout the world are most closely equal in length (closer to 12h/12h) than on any other date of the year.&nbsp; There are two equinoxes each year marking the dates on which the spring and autumn seasons begin and the apparent geocentric sun crosses the celestial equator.
<br><br>
<hr>

<div align='center'><b>THE 8 SEASONS OF THE YEAR</b></div><br>
Although there are 2 equinoxes and 2 solstices each calendar year, there are actually 8 distinct seasons in each year.&nbsp; This is because during each calendar year, there are two distinct occurrences of each season at six-month intervals.&nbsp; The southern hemisphere experiences the same seasons as the northern hemisphere, but southern seasons are six months offset from the same northern seasons, hence distinct.
<br><br>
For example, when it is winter in New York City, USA, it is summer in Sydney, Australia and vice versa.&nbsp; Both places experience winter and summer during the same year, but those seasons are some 6 months apart and quite distinct from each other.&nbsp; The same applies equally to all the other seasons as well, so that each of the 4 seasons occurs 2 times during each calendar year, once in each hemisphere, half a year apart, for a total of 2×4 = 8 distinct seasons every year.
<br><br>

</div>

<hr>

<div style='font-size:125%; text-align:left;'>
<b>Let</b>: &nbsp; <b style='color:blue;'>Blue Seasons</b> = Northern hemisphere and <b style='color:red;'>Red Seasons</b> = Southern hemisphere
<br><br>

<ul>
<li><b style='color:blue;'>Spring</b><b>/</b><b style='color:red;'>Autumn</b> - Equinox<br>
Begins at the moment when the apparent geocentric sun reaches declination = 0&deg;<br><br>Sun crosses geocentric celestial equator from south to north.<br><br><img src='images/earth_spring-autumn_view.png' alt=''><br><br><br><hr></li>

<li><b style='color:blue;'>Summer</b><b>/</b><b style='color:red;'>Winter</b> - Solstice<br>
Begins at the moment when the apparent geocentric sun reaches RA = 06h (90&deg;).<br><br>Sun appears stationary at its northernmost declination (approx. <code>+23.45</code>&deg;),<br>before heading back south a little more each day.<br><br><img src='images/earth_summer-winter_view.png' alt=''><br><br><br><hr></li>

<li><b style='color:blue;'>Autumn</b><b>/</b><b style='color:red;'>Spring</b> - Equinox<br>
Begins at the moment when the apparent geocentric sun reaches declination = 0&deg;<br><br>Sun crosses geocentric celestial equator from north to south.<br><br><img src='images/earth_autumn-spring_view.png' alt=''><br><br><br><hr></li>

<li><b style='color:blue;'>Winter</b><b>/</b><b style='color:red;'>Summer</b> - Solstice<br>
Begins at the moment when the apparent geocentric sun reaches RA = 18h (270&deg;).<br><br>Sun appears stationary at its southernmost declination (approx. <code>-23.45</code>&deg;),<br>before heading back north a little more each day.<br><br><img src='images/earth_winter-summer_view.png' alt=''><br><br><br></li>
</ul>
</div>
</td></tr>
</table>

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

</body>
</html>

_HTML;





/*

This is the next generation (VII) basic astronomy 101 module in PHP.

Author   : Jay Tanner - 2014 Dec 03
Language : PHP v5.4.7

License  : Creative Commons Attribution/Share-Alike License v3
           https://creativecommons.org/licenses/by-sa/3.0/


CHANGES:
LaGrange_Interpolate(...) function was shortened to LaGrange_Interp(...)
=============================================================================
LEVEL 0 FUNCTIONS LIST: These functions are stand-alone and transportable.

Strip_WSpace ($TextString)
Swap (&$var1, &$var2)

Mean_Eps ($JDTT)
Mean_Sid_Time ($JDTT, $LngDeg=0)

dEps_2000B($JDTT)
dPsi_2000B($JDTT)

sin_d($AngDeg)
cos_d($AngDeg)
tan_d($AngDeg)

asin_d($x)
acos_d($x)
atan_d($x)
atan2_d($y, $x)

Deg_Mod_360 ($DegStr)

Deg_to_DMS ($AngDeg, $ssDecimals=0, $PosSignFlag=FALSE, $SymbolsFlag=TRUE)
Deg_to_HMS ($AngDeg, $ssDecimals=0, $PosSignFlag=FALSE, $SymbolsFlag=TRUE)

Hours_to_HMS ($hours, $ssDecimals=0, $PosSignFlag=FALSE, $SymbolsFlag=TRUE)

DMS_to_Deg ($DMSStr)

LaGrange_Interp ($XvsYDataTable, $xArg)
Swap_Data_Columns ($XvsYDataTable)

Extremum5 ($DataTableStr)


=============================================================================
LEVEL 1 FUNCTIONS LIST: These functions call one or more level 0 functions.

Date_Time_TZ_to_JDTT ($DateTimeTZ, $dTFlag=TRUE)

JDTT_TZ_to_Date_Time ($JDTT_TZ, $dTFlag=TRUE)

dEquinox_2000B ($JDTT)



=============================================================================
*/


// -----------------------------------------------------------------------
// This function strips all leading, trailing and internal whitespace from
// within a text string.  All occurrences of multiple spaces within the
// text string will be replaced by single spaces and all leading and
// trailing whitespace will also be removed.

   function Strip_WSpace ($TextString)
{
   return preg_replace("/\s+/", " ", trim($TextString));
}


/*
   ---------------------------------------
   This function simply swaps the contents
   of two simple variable arguments.
*/

   function Swap (&$var1, &$var2)
 {
   $w=$var1;  $var1=$var2;  $var2=$w;
 }

















/*
   ===================================================================
   Level(1)

   This function computes the full astronomical JD (Julian Day) number
   on the TT scale for any given local date, time and time zone over
   the 600 year span from 1600 to 2200.

   Times are assumed to be standard zone times.  No daylight saving or
   summer time adjustment is applied.

   ARGUMENTS:
   $DateTimeTZString = Local Date/Time/Zone string (Ex. "19490520 18:40 -5")
   $dTFlag = Delta T flag = TRUE=Default or NOT TRUE.

   Example Date/Time/Zone argument string for
   1949 May 20 at 20:52 (8:52 PM) in TZ -05:00
   = "19490520 20:52 -05:00"
   For UT, TZ = +00:00 = Default

   If dTFlag === TRUE (default), given time is converted to TT.
   If dTFlag is NOT TRUE, given time is already TT.
   NOT TRUE = FALSE = Anything other than TRUE.
   ===================================================================
*/

   function Date_Time_TZ_to_JDTT ($DateTimeTZString, $dTFlag=TRUE)
{
// Strip all redundant white space from date/time/zone string
// and copy into temporary working string (w).
   $w = strip_wspace($DateTimeTZString);

// Count the number of date/time/zone elements (1 to 3).
// They are "Date Time Zone", delimited by spaces.
// Time and Zone default to zero if not specified
// so that all 3 elements will be defined before
// being called for computations.
   $k = 1 + substr_count($w, " ");

// Construct full "date time zone" elements string, inserting
// default time/zone values for elements not specified.
   $hhmmss = $TZhhmm = "00:00";

   if ($k == 3) {list($Ymd, $hhmmss, $TZhhmm) = preg_split("[ ]", $w);}
   if ($k == 2) {list($Ymd, $hhmmss) = preg_split("[ ]", $w);}
   if ($k == 1) {$Ymd = $w;}

// Tidy up time and zone strings.
   $hhmmss = Hours_to_HMS(HMS_to_Hours($hhmmss));
   $TZhhmm = Hours_to_HMS(HMS_to_Hours($TZhhmm, TRUE));

// Arithmatically parse the integer-encoded date string to get
// the individual date elements (Y,m,d) from within it.
   $Y = floor($Ymd / 10000);
   $m = floor(($Ymd - 10000*$Y) / 100);
   $d = $Ymd - 10000*$Y - 100*$m;

// Check date for validity (must be in the range from 1600 to 2200).
// If date is invalid, FALSE is returned.
   if(!(checkdate($m,$d,$Y) or $Y >= 1600 or $Y <= 2200)) {return FALSE;}

// Compute Gregorian JD number for 00h of date.
   $JD00 = GregorianToJD($m, $d, $Y) - 0.5;

// Compute the fraction of a day corresponding
// to the given local time (hhmmss) string.
   $LTFrac = HMS_to_Hours($hhmmss)/24;

// Compute the fraction of a day corresponding
// to the given time zone (TZhhmm) string.
   $TZFrac = HMS_to_Hours($TZhhmm)/24;

// ***************************************************
// Apply Optional Delta T (Default flag state = TRUE).
// FALSE assumes that time argument is already TT.
// In this case, FALSE means anything other than TRUE.
   if ($dTFlag === TRUE)
  {
// Compute NASA Delta T estimate as fraction
// of a day resolved to the nearest second.
   $dTsec  = sprintf('%+1.0f', Delta_T($Ymd));
   $dTFrac = sprintf('%+1.8f', $dTsec / 86400);
  }

 else

  {
   $dTFrac = 0.0;
  }

// Compute 3 more flavors of JD numbers from JD00.
   $JDLT = sprintf("%1.8f", $JD00 + $LTFrac);
   $JDUT = sprintf("%1.8f", $JDLT - $TZFrac);
   $JDTT = sprintf("%1.8f", $JDUT + $dTFrac);

// Tidy up Time Zone string.
   $TZhhmm = Hours_to_HMS(HMS_to_Hours($TZhhmm), 0, TRUE);
   $TZhhmm = str_replace(":00s", "", $TZhhmm);

// Trim any redundant zeros and/or decimal point.
   $w = rtrim(rtrim($JDTT, '0'), '.') . " $TZhhmm";

// Cut off seconds from end of TZ.  Done.
   return substr($w, 0, strlen($w)-3);

} // End of  Date_Time_TZ_to_JDTT (...)






/*
   =========================================================================
   Level(1)

   This function serves as an inverse JDTT function.  Given a JDTT argument
   and local time zone offset, this function returns the local date and time
   resolved to the nearest second.

   NOTE:
   The optional Delta T value is resolved to the nearest second.
   =========================================================================
*/

   function JDTT_TZ_to_Date_Time ($JDTT_TZ, $dTFlag=TRUE)
{
// Strip all redundant white space from JDTT/zone string
// and copy into temporary working variable (w).
   $w = strip_wspace($JDTT_TZ);

// If no time zone given, then set default = UT.
   if (strpos($w, " ") === FALSE) {$w .= " +00:00";}

   list($JDTT, $TZhhmm) = preg_split("[ ]", $w);

// Tidy up Time Zone string.
   $TZhhmm = Hours_to_HMS(HMS_to_Hours($TZhhmm), 0, TRUE);

// Compute dT as fraction of a day.
   $TZFrac = HMS_to_Hours($TZhhmm)/24;

// Compute JD12TT value for date corresponding to JDTT argument.
   $JD12TT = floor($JDTT + 0.5);

// Compute Gregorian date corresponding to the JD argument.
   list($m, $d, $Y) = preg_split("[\/]", JDtoGregorian($JD12TT));

// Optionally apply Delta T (Default dTFlag === TRUE).
    $dTsec = $dTFrac = 0;

   if ($dTFlag === TRUE)
{
   $dTseconds = Delta_T ($Y*100 + $m);         // Raw value in seconds.
   $dTsec  = sprintf("%+1.0f", $dTseconds);    // To nearest second.
   $dTFrac = sprintf("%+1.16f", $dTsec/86400); // As fraction of a day.
}

// Compute JDUT by subtracting dTFrac from JDTT.
   $JDUT = sprintf("%1.8f", $JDTT - $dTFrac);

// Compute JDLT for local time zone from JDUT.
   $JDLT = sprintf("%1.8f", $JDUT + $TZFrac);

// Compute JD12LT for local standard date and time.
   $JD12LT = floor($JDLT + 0.5);

// Compute Gregorian date corresponding to the JDLT.
   list($m, $d, $Y) = preg_split("[\/]", JDtoGregorian($JD12LT));

// Force month and day values into 2-digit format.
   $m = sprintf("%02d", $m);
   $d = sprintf("%02d", $d);

// Construct integer encoded date from date elements.
   $Ymd = "$Y$m$d";

// Convert fractional part of JDLT into hours local time.
   $j = bcsub($JDLT, "0.5", 16);
   $hours = bcmul(24, "0" . substr($j, strpos($j, "."), strlen($j)), 16);

// Compute local time elements (hh,mm,ss).
   $hh      = floor($hours);
   $minutes = 60*($hours - $hh);
   $mm      = floor($minutes);
   $seconds = 60*($minutes - $mm);

// Format (hh, mm, ss) values for output.
// ss is rounded to nearest second.
   $hh = sprintf("%02d",  $hh);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%02d",  $seconds + 0.5);

// Adjust time to nearest minute.
   if (FloatVal($ss) >= 30) {$mm++;  $ss = '  ';}else{$ss = '  ';}

// Patch for that blasted 60 glitch.
   $mm = sprintf("%02d",  $mm);
   if ($ss == 60){$ss = "00";  $mm = sprintf("%02d",  $mm+1);}
   if ($mm == 60){$mm = "00";  $hh = sprintf("%02d",  $hh+1);}

// Remove seconds part of TZ because
// it always equates to zero anyway.
// w = 20220320 15:35: +00:00:00
   $w = "$Ymd $hh:$mm:$ss $TZhhmm";
//   exit("$w");
   $w = substr($w, 0, strlen($w)-3);

   $w = Str_Replace(': ', '  ', $w);

// Done.
   return $w;

} // End of  JDTT_TZ_to_Date_Time(...)





/*
   ===================================================================
   Level(0)

   This function computes the local or Greenwich mean sidereal time in
   degrees for any given JD and geographic longitude arguments.

   ARGUMENTS:
   JDTT    = JD argument for any given date and time (TT)

   LngDeg  = Geographic longitude. (Negative = West)
             Default longitude = 0 degrees (= Greenwich)

   ERRORS:
   FALSE is returned if either argument is invalid.
   ===================================================================
*/

   function Mean_Sid_Time ($JDTT, $LngDeg=0)
{
// ------------------------------
// Check for invalid argument(s).
   if ($JDTT < 2305447 or $JDTT > 2524959 or !is_numeric($LngDeg)) {return FALSE;}

// ------------------------------------------------
// Compute time (t) in Julian millennia as reckoned
// from J2000.0 and corresponding to the JD number.
   $t = ($JDTT - 2451545) / 36525;

// ------------------------------------------------
// Compute Greenwich mean sidereal time in degrees.
   $GSTMeanDeg = 280.46061837 + 360.98564736629*($JDTT - 2451545)
               + ($t*$t * 0.000387993) - ($t*$t*$t / 38710000);

// -----------------------------------
// Compute local mean sidereal time at
// the given geographic longitude.
   $LSTMeanDeg = $GSTMeanDeg + $LngDeg;

// ----------------------------------------------------------------
// Modulate sidereal time angle to fall between 0 and +360 degrees.
   $w = abs($LSTMeanDeg);
   $w = (($LSTMeanDeg < 0)? -1:1)*($w - 360*floor($w/360));
   $w += ($w < 0)? 360:0;
   $LSTMeanDeg = $w;
   $LSTMeanHrs = $LSTMeanDeg / 15;

// -------------------------------------------
// Return mean sidereal time angle in degrees.
   return rtrim(rtrim($LSTMeanDeg,'0'), '.');

}  // End of  Mean_Sid_Time (...)








/*
  ========================================================================
  This function computes the mean obliquity of the ecliptic in degrees
  for the current JDTT argument corresponding to any given date/time.

  This ecliptic obliquity function is based on a formula derived by
  J. Laskar, Astronomy and Astrophysics, 1968, Vol. 157, p68.

  The estimated accuracy of this formula is ±0.01 arc second between
  the years 1000 AD and 3000 AD and a few arc seconds after 10,000
  years.  It is only valid in the range ±10,000 years either way
  of J2000.0

  Over the long term, it is more accurate than the formula adopted by
  the International Astronomical Union (IAU).


  ---------
  ARGUMENT:
  $JDTT = JD number at the moment (TDB) for which the mean obliquity
          of the ecliptic is required.
  ========================================================================
*/

   function Mean_Eps ($JDTT)
{

// ----------------------------------------------
// Compute the time in Julian centuries reckoned
// from J2000.0 corresponding to the JD argument
// and then divide by 100 for decamillennia.

   $t = ($JDTT - 2451545) / 36525 / 100;

// ------------------------------------------
// Compute mean obliquity (e) of the ecliptic
// expressed in arc seconds.

   $p = $t*$t;

   $e = 84381.448 - 4680.93*$t;

   $e -=    1.55*$p;  $p *= $t;
   $e += 1999.25*$p;  $p *= $t;
   $e -=   51.38*$p;  $p *= $t;
   $e -=  249.67*$p;  $p *= $t;
   $e -=   39.05*$p;  $p *= $t;
   $e +=    7.12*$p;  $p *= $t;
   $e +=   27.87*$p;  $p *= $t;
   $e +=    5.79*$p;  $p *= $t;
   $e +=    2.45*$p;

// -----------------------------------
// Done.  Return obliquity in degrees.
   return $e / 3600;

} // End of  Mean_Eps (...)






/*
  ========================================================================
  This function computes the nutation in obliquity (delta epsilon)
  in degrees according to the IAU 2000B nutation series.

  This value is applied to the mean obliquity of the ecliptic to
  obtain the true, apparent obliquity.

  The series consists of 77 terms.

  ARGUMENT:
  $JD = JD number at the moment (TDB) for which the
        nutation in obliquity is required.

  ERRORS:
  No error checking.

  ========================================================================
*/


   function dEps_2000B($JDTT)
{

   $T = ($JDTT - 2451545) / 36525;

   $T2 = $T * $T;
   $T3 = $T * $T2;
   $T4 = $T * $T3;

// -------------------------------------------
// Compute mean anomaly of the Moon in radians

   $L  = deg2rad((485868.249036 + 1717915923.2178*$T + 31.8792*$T2
       + 0.051635*$T3 - 0.0002447*$T4) / 3600);


// ------------------------------------------
// Compute mean anomaly of the Sun in radians

   $Lp = deg2rad((1287104.79305 + 129596581.0481*$T
       - 0.5532*$T2  + 0.000136*$T3 - 0.00001149*$T4) / 3600);


// ------------------------------------------------------------
// Compute mean argument of the latitude of the Moon in radians

   $F  = deg2rad((335779.526232 + 1739527262.8478*$T
       - 12.7512*$T2 - 0.001037*$T3 + 0.00000417*$T4) / 3600);


// -----------------------------------------------------------
// Compute mean elongation of the Moon from the Sun in radians

   $D  = deg2rad((1072260.70369 + 1602961601.2090*$T
       - 6.3706*$T2  + 0.006593*$T3 - 0.00003169*$T4) / 3600);


// ------------------------------------------------------------------------
// Compute mean longitude of the mean ascending node of the Moon in radians

   $Om = deg2rad((450160.398036 - 6962890.5431*$T
       + 7.4722*$T2  + 0.007702*$T3 - 0.00005939*$T4) / 3600);

// --------------------------------------------------------------
// Sum series for nutation in obliquity (dEps) in arc sec * 10E+7

$s = 0;
$s += (92052331 + 9086*$T)*cos($Om) + 15377*sin($Om);
$s += (5730336 - 3015*$T)*cos(2*($F - $D + $Om)) - 4587*sin(2*($F - $D + $Om));
$s += (978459 - 485*$T)*cos(2*($F + $Om)) + 1374*sin(2*($F + $Om));
$s += (-897492 + 470*$T)*cos(2*$Om) - 291*sin(2*$Om);
$s += (73871 - 184*$T)*cos($Lp) - 1924*sin($Lp);
$s += (224386 - 677*$T)*cos($Lp + 2*($F - $D + $Om)) - 174*sin($Lp + 2*($F - $D + $Om));
$s -= 6750*cos($L) - 358*sin($L);
$s += (200728 + 18*$T)*cos(2*$F + $Om) + 318*sin(2*$F + $Om);
$s += (129025 - 63*$T)*cos($L + 2*($F + $Om)) + 367*sin($L + 2*($F + $Om));
$s += (-95929 + 299*$T)*cos(2*($F - $D + $Om) - $Lp) + 132*sin(2*($F - $D + $Om) - $Lp);
$s += (-68982 - 9*$T)*cos(2*($F - $D) + $Om) + 39*sin(2*($F - $D) + $Om);
$s += (-53311 + 32*$T)*cos(2*($F + $Om) - $L) - 4*sin(2*($F + $Om) - $L);
$s -= 1235*cos(2*$D - $L) - 82*sin(2*$D - $L);
$s -= 33228*cos($L + $Om) + 9*sin($L + $Om);
$s += 31429*cos($Om - $L) - 75*sin($Om - $L);
$s += (25543 - 11*$T)*cos(2*($F + $D + $Om) - $L) + 66*sin(2*($F + $D + $Om) - $L);
$s += 26366*cos($L + 2*$F + $Om) + 78*sin($L + 2*$F + $Om);
$s += (-24236 - 10*$T)*cos(2*($F - $L) + $Om) + 20*sin(2*($F - $L) + $Om);
$s -= 1220*cos(2*$D) - 29*sin(2*$D);
$s += (16452 - 11*$T)*cos(2*($F + $D + $Om)) + 68*sin(2*($F + $D + $Om));
$s -= 13870*cos(-2*($Lp - $F + $D - $Om));
$s += 477*cos(2*($D - $L)) - 25*sin(2*($D - $L));
$s += (13238 - 11*$T)*cos(2*($L + $F + $Om)) + 59*sin(2*($L + $F + $Om));
$s += (-12338 + 10*$T)*cos($L + 2*($F - $D + $Om)) - 3*sin($L + 2*($F - $D + $Om));
$s -= 10758*cos(2*$F + $Om - $L) + 3*sin(2*$F + $Om - $L);
$s -= 609*cos(2*$L) - 13*sin(2*$L);
$s -= 550*cos(2*$F) - 11*sin(2*$F);
$s += (8551 - 2*$T)*cos($Lp + $Om) - 45*sin($Lp + $Om);
$s -= 8001*cos(-$L + 2*$D + $Om) + sin(-$L + 2*$D + $Om);
$s += (6850 - 42*$T)*cos(2*($Lp + $F - $D + $Om)) - 5*sin(2*($Lp + $F - $D + $Om));
$s -= 167*cos(2*($D - $F)) - 13*sin(2*($D - $F));
$s += 6953*cos($L - 2*$D + $Om) - 14*sin($L - 2*$D + $Om);
$s += 6415*cos($Om - $Lp) + 26*sin($Om - $Lp);
$s += 5222*cos(2*($F + $D) + $Om - $L) + 15*sin(2*($F + $D) + $Om - $L);
$s += (168 - $T)*cos(2*$Lp) + 10*sin(2*$Lp);
$s += 3268*cos($L + 2*($F + $D + $Om)) + 19*sin($L + 2*($F + $D + $Om));
$s += 104*cos(2*($F - $L)) + 2*sin(2*($F - $L));
$s -= 3250*cos($Lp + 2*($F + $Om)) + 5*sin($Lp + 2*($F + $Om));
$s += 3353*cos(2*($F + $D) + $Om) + 14*sin(2*($F + $D) + $Om);
$s += 3070*cos(2*($F + $Om) - $Lp) + 4*sin(2*($F + $Om) - $Lp);
$s += 3272*cos(2*$D + $Om) + 4*sin(2*$D + $Om);
$s -= 3045*cos($L + 2*($F - $D) + $Om) + sin($L + 2*($F - $D) + $Om);
$s -= 2768*cos(2*($L + $F - $D + $Om)) + 4*sin(2*($L + $F - $D + $Om));
$s += 3041*cos(2*($D - $L) + $Om) - 5*sin(2*($D - $L) + $Om);
$s += 2695*cos(2*($L + $F) + $Om) + 12*sin(2*($L + $F) + $Om);
$s += 2719*cos(2*($F - $D) + $Om - $Lp) - 3*sin(2*($F - $D) + $Om - $Lp);
$s += 2720*cos($Om - 2*$D) - 9*sin($Om - 2*$D);
$s -= 51*cos(-$L - $Lp + 2*$D) - 4*sin(-$L - $Lp + 2*$D);
$s -= 2206*cos(2*($L - $D) + $Om) - sin(2*($L - $D) + $Om);
$s -= 199*cos($L + 2*$D) - 2*sin($L + 2*$D);
$s -= 1900*cos($Lp + 2*($F - $D) + $Om) - sin($Lp + 2*($F - $D) + $Om);
$s -= 41*cos($L - $Lp) - 3*sin($L - $Lp);
$s += 1313*cos(-2*($L - $F - $Om)) - sin(-2*($L - $F - $Om));
$s += 1233*cos(3*$L + 2*($F + $Om)) + 7*sin(3*$L + 2*($F + $Om));
$s -= 81*cos(-$Lp + 2*$D) - 2*sin(-$Lp + 2*$D);
$s += 1232*cos($L - $Lp + 2*($F + $Om)) + 4*sin($L - $Lp + 2*($F + $Om));
$s -= 20*cos($D) + 2*sin($D);
$s += 1207*cos(2*($F + $D + $Om) - $L - $Lp) + 3*sin(2*($F + $D + $Om) - $L - $Lp);
$s += 40*cos(2*$F - $L) - 2*sin(2*$F - $L);
$s += 1129*cos(-$Lp + 2*($F + $D + $Om)) + 5*sin(-$Lp + 2*($F + $D + $Om));
$s += 1266*cos($Om - 2*$L) - 4*sin($Om - 2*$L);
$s -= 1062*cos($L + $Lp + 2*($F + $Om)) + 3*sin($L + $Lp + 2*($F + $Om));
$s -= 1129*cos(2*$L + $Om) + 2*sin(2*$L + $Om);
$s -= 9*cos($Lp + $D - $L);
$s += 35*cos($L + $Lp) - 2*sin($L + $Lp);
$s -= 107*cos($L + 2*$F) - sin($L + 2*$F);
$s += 1073*cos(2*($F - $D) + $Om - $L) - 2*sin(2*($F - $D) + $Om - $L);
$s += 854*cos($L + 2*$Om);
$s -= 553*cos($D - $L) + 139*sin($D - $L);
$s -= 710*cos(2*($F + $Om) + $D) + 2*sin(2*($F + $Om) + $D);
$s += 647*cos(2*($F + 2*$D + $Om) - $L) + 4*sin(2*($F + 2*$D + $Om) - $L);
$s -= 700*cos($Lp + $D + $Om - $L);
$s += 672*cos(-2*($Lp - $F + $D) + $Om);
$s += 663*cos($L + 2*($F + $D) + $Om) + 4*sin($L + 2*($F + $D) + $Om);
$s -= 594*cos(-2*($L - $F - $D - $Om)) + 2*sin(-2*($L - $F - $D - $Om));
$s -= 610*cos(2*$Om - $L) - 2*sin(2*$Om - $L);
$s -= 556*cos($L + $Lp + 2*($F - $D + $Om));

// ----------------------------
// Return nutation in obliquity
// expressed in degrees.

   return $s / 36000000000;


} // End of  dEps_2000B(...)




/*

   ========================================================================
   This function computes the nutation in ecliptical longitude (Delta psi)
   in degrees according to the IAU 2000B nutation series.

   This value is applied to the mean ecliptical longitude to obtain the
   true, apparent ecliptical longitude.

   The series consists of 77 terms.

   ARGUMENT:
   $JDTT = Astronomical JD number corresponding to date and time (TT).

   ERRORS:
   No error checking.
   ========================================================================
*/

   function dPsi_2000B ($JDTT)
{

// ---------------------------------------------
// Compute time (T) in Julian centuries reckoned
// from J2000.0 and 4 powers of T.

   $T  = ($JDTT - 2451545) / 36525;

   $T2 = $T * $T;
   $T3 = $T * $T2;
   $T4 = $T * $T3;

// -------------------------------------------
// Compute mean anomaly of the Moon in radians

   $L  = deg2rad((485868.249036 + 1717915923.2178*$T + 31.8792*$T2
       + 0.051635*$T3 - 0.0002447*$T4) / 3600);


// ------------------------------------------
// Compute mean anomaly of the Sun in radians

   $Lp = deg2rad((1287104.79305 + 129596581.0481*$T
       - 0.5532*$T2  + 0.000136*$T3 - 0.00001149*$T4) / 3600);


// ------------------------------------------------------------
// Compute mean argument of the latitude of the Moon in radians

   $F  = deg2rad((335779.526232 + 1739527262.8478*$T
       - 12.7512*$T2 - 0.001037*$T3 + 0.00000417*$T4) / 3600);


// -----------------------------------------------------------
// Compute mean elongation of the Moon from the Sun in radians

   $D  = deg2rad((1072260.70369 + 1602961601.2090*$T
       - 6.3706*$T2  + 0.006593*$T3 - 0.00003169*$T4) / 3600);


// ------------------------------------------------------------------------
// Compute mean longitude of the mean ascending node of the Moon in radians

   $Om = deg2rad((450160.398036 - 6962890.5431*$T
       + 7.4722*$T2  + 0.007702*$T3 - 0.00005939*$T4) / 3600);

// -----------------------------------------------------------------------
// Sum 2000B series for nutation in longitude (dPsi) in arc sec * 10000000

$s = 0;
$s += (-172064161 - 174666*$T)*sin($Om) + 33386*cos($Om);
$s += (-13170906 - 1675*$T)*sin(2*($F - $D + $Om)) - 13696*cos(2*($F - $D + $Om));
$s += (-2276413 - 234*$T)*sin(2*($F + $Om)) + 2796*cos(2*($F + $Om));
$s += (2074554 + 207*$T)*sin(2*$Om) - 698*cos(2*$Om);
$s += (1475877 - 3633*$T)*sin($Lp) + 11817*cos($Lp);
$s += (-516821 + 1226*$T)*sin($Lp + 2*($F - $D + $Om)) - 524*cos($Lp + 2*($F - $D + $Om));
$s += (711159 + 73*$T)*sin($L) - 872*cos($L);
$s += (-387298 - 367*$T)*sin(2*$F + $Om) + 380*cos(2*$F + $Om);
$s += (-301461 - 36*$T)*sin($L + 2*($F + $Om)) + 816*cos($L + 2*($F + $Om));
$s += (215829 - 494*$T)*sin(2*($F - $D + $Om) - $Lp) + 111*cos(2*($F - $D + $Om) - $Lp);
$s += (128227 + 137*$T)*sin(2*($F - $D) + $Om) + 181*cos(2*($F - $D) + $Om);
$s += (123457 + 11*$T)*sin(2*($F + $Om) - $L) + 19*cos(2*($F + $Om) - $L);
$s += (156994 + 10*$T)*sin(2*$D - $L) - 168*cos(2*$D - $L);
$s += (63110 + 63*$T)*sin($L + $Om) + 27*cos($L + $Om);
$s += (-57976 - 63*$T)*sin($Om - $L) - 189*cos($Om - $L);
$s += (-59641 - 11*$T)*sin(2*($F + $D + $Om) - $L) + 149*cos(2*($F + $D + $Om) - $L);
$s += (-51613 - 42*$T)*sin($L + 2*$F + $Om) + 129*cos($L + 2*$F + $Om);
$s += (45893 + 50*$T)*sin(2*($F - $L) + $Om) + 31*cos(2*($F - $L) + $Om);
$s += (63384 + 11*$T)*sin(2*$D) - 150*cos(2*$D);
$s += (-38571 - $T)*sin(2*($F + $D + $Om)) + 158*cos(2*($F + $D + $Om));
$s += 32481*sin(2*($F - $Lp - $D + $Om));
$s -= 47722*sin(2*($D - $L)) + 18*cos(2*($D - $L));
$s += (-31046 - $T)*sin(2*($L + $F + $Om)) + 131*cos(2*($L + $F + $Om));
$s += 28593*sin($L + 2*($F - $D + $Om)) - cos($L + 2*($F - $D + $Om));
$s += (20441 + 21*$T)*sin(2*$F - $L + $Om) + 10*cos(2*$F - $L + $Om);
$s += 29243*sin(2*$L) - 74*cos(2*$L);
$s += 25887*sin(2*$F) - 66*cos(2*$F);
$s += (-14053 - 25*$T)*sin($Lp + $Om) + 79*cos($Lp + $Om);
$s += (15164 + 10*$T)*sin(2*$D - $L + $Om) + 11*cos(2*$D - $L + $Om);
$s += (-15794 + 72*$T)*sin(2*($Lp + $F - $D + $Om)) - 16*cos(2*($Lp + $F - $D + $Om));
$s += 21783*sin(2*($D - $F)) + 13*cos(2*($D - $F));
$s += (-12873 - 10*$T)*sin($L - 2*$D + $Om) - 37*cos($L - 2*$D + $Om);
$s += (-12654 + 11*$T)*sin($Om - $Lp) + 63*cos($Om - $Lp);
$s -= 10204*sin(2*($F + $D) - $L + $Om) - 25*cos(2*($F + $D) - $L + $Om);
$s += (16707 - 85*$T)*sin(2*$Lp) - 10*cos(2*$Lp);
$s -= 7691*sin($L + 2*($F + $D + $Om)) - 44*cos($L + 2*($F + $D + $Om));
$s -= 11024*sin(-2*$L + 2*$F) + 14*cos(2*($F - $L));
$s += (7566 - 21*$T)*sin($Lp + 2*($F + $Om)) - 11*cos($Lp + 2*($F + $Om));
$s += (-6637 - 11*$T)*sin(2*($F + $D) + $Om) + 25*cos(2*($F + $D) + $Om);
$s += (-7141 + 21*$T)*sin(2*($F + $Om) - $Lp) + 8*cos(2*($F + $Om) - $Lp);
$s += (-6302 - 11*$T)*sin(2*$D + $Om) + 2*cos(2*$D + $Om);
$s += (5800 + 10*$T)*sin($L + 2*($F - $D) + $Om) + 2*cos($L + 2*($F - $D) + $Om);
$s += 6443*sin(2*($L + $F - $D + $Om)) - 7*cos(2*($L + $F - $D + $Om));
$s += (-5774 - 11*$T)*sin(2*($D - $L) + $Om) - 15*cos(2*($D - $L) + $Om);
$s -= 5350*sin(2*($L + $F) + $Om) - 21*cos(2*($L + $F) + $Om);
$s += (-4752 - 11*$T)*sin(2*($F - $D) - $Lp + $Om) - 3*cos(2*($F - $D) - $Lp + $Om);
$s += (-4940 - 11*$T)*sin($Om - 2*$D) - 21*cos($Om - 2*$D);
$s += 7350*sin(2*$D - $L - $Lp) - 8*cos(2*$D - $L - $Lp);
$s += 4065*sin(2*($L - $D) + $Om) + 6*cos(2*($L - $D) + $Om);
$s += 6579*sin($L + 2*$D) - 24*cos($L + 2*$D);
$s += 3579*sin($Lp + 2*($F - $D) + $Om) + 5*cos($Lp + 2*($F - $D) + $Om);
$s += 4725*sin($L - $Lp) - 6*cos($L - $Lp);
$s -= 3075*sin(2*($F - $L  + $Om)) + 2*cos(2*($F - $L  + $Om));
$s -= 2904*sin(3*$L + 2*($F + $Om)) - 15*cos(3*$L + 2*($F + $Om));
$s += 4348*sin(2*$D - $Lp) - 10*cos(2*$D - $Lp);
$s -= 2878*sin($L - $Lp + 2*($F + $Om)) - 8*cos($L - $Lp + 2*($F + $Om));
$s -= 4230*sin($D) - 5*cos($D);
$s -= 2819*sin(2*($F + $D + $Om) - $L - $Lp) - 7*cos(2*($F + $D + $Om) - $L - $Lp);
$s -= 4056*sin(2*$F - $L) - 5*cos(2*$F - $L);
$s -= 2647*sin(2*($F + $D + $Om) - $Lp) - 11*cos(2*($F + $D + $Om) - $Lp);
$s -= 2294*sin($Om - 2*$L) + 10*cos($Om - 2*$L);
$s += 2481*sin($L + $Lp + 2*($F + $Om)) - 7*cos($L + $Lp + 2*($F + $Om));
$s += 2179*sin(2*$L + $Om) - 2*cos(2*$L + $Om);
$s += 3276*sin($Lp - $L + $D) + cos($Lp - $L + $D);
$s -= 3389*sin($L + $Lp) - 5*cos($L + $Lp);
$s += 3339*sin($L + 2*$F) - 13*cos($L + 2*$F);
$s -= 1987*sin(2*($F - $D) - $L + $Om) + 6*cos(2*($F - $D) - $L + $Om);
$s -= 1981*sin($L + 2*$Om);
$s += 4026*sin($D - $L) - 353*cos($D - $L);
$s += 1660*sin($D + 2*($F + $Om)) - 5*cos($D + 2*($F + $Om));
$s -= 1521*sin(2*($F + 2*$D + $Om) - $L) - 9*cos(2*($F + 2*$D + $Om) - $L);
$s += 1314*sin($Lp - $L + $D + $Om);
$s -= 1283*sin(2*($F - $Lp - $D) + $Om);
$s -= 1331*sin($L + 2*($F + $D) + $Om) - 8*cos($L + 2*($F + $D) + $Om);
$s += 1383*sin(2*($F - $L + $D + $Om)) - 2*cos(2*($F - $L + $D + $Om));
$s += 1405*sin(2*$Om - $L) + 4*cos(2*$Om - $L);
$s += 1290*sin($L + $Lp + 2*($F - $D + $Om));

// ----------------------------------------
// Return nutation in longitude in degrees.

   return $s / 36000000000;

} // End of  dPsi_2000B()





// ========================================================================
// Alternate trig functions for degree arguments instead of radians.
// Same names as original functions except with trailing _d chars.

   function sin_d($AngDeg)
  {
   return sin(deg2rad($AngDeg));
  }

   function cos_d($AngDeg)
  {
   return cos(deg2rad($AngDeg));
  }

   function tan_d($AngDeg)
  {
   return tan(deg2rad($AngDeg));
  }

   function asin_d($x)
  {
   return rad2deg(asin($x));
  }

   function acos_d($x)
  {
   return rad2deg(acos($x));
  }

   function atan_d($x)
  {
   return rad2deg(atan($x));
  }

   function atan2_d($y, $x)
  {
   $w = rad2deg(atan2($y, $x));

   return $w + (($w < 0)? 360:0); // 0 to +360 degrees
  }








/*
   ========================================================================
   This function modulates a negative or positive angle to fall within the
   range from 0 to +360 degrees to help handle angles that fall outside
   the standard circular values.  For example, -5 degrees would be
   converted to +355 degrees or 417 degrees would be converted
   to 57 degrees, etc.

   This function uses arbitrary precision arithmetic.


   ARGUMENTS:
   $DegStr = Degrees argument as a numerical string.
   ========================================================================
*/

   function Deg_Mod_360 ($DegStr)

{
   $SignVal = ($DegStr < 0)? -1:1;

   $a = bcmul($SignVal, "$DegStr", 20);

   $b = bcmul($SignVal, bcsub($a, bcmul(360, bcdiv($a, 360)), 20), 20);

   return rtrim(rtrim(bcadd($b, (($b < 0)? 360:0), 16), "0"), ".");

} // End of  Deg_Mod_360()




/*
   ========================================================================
   Convert decimal degrees to degrees, minutes, seconds of arc.
   The angular elements are returned in a space-delimited string.

   Optional symbols are attached to the angle elements. The seconds can
   optionally be rounded to up to 3 decimals with 0=Default.

   ========================================================================
*/

   function Deg_to_DMS ($AngDeg, $ssDecimals=0, $PosSignFlag=FALSE, $SymbolsFlag=TRUE)
{

// Init
   $_d_ = $_m_ = $_s_ = '';

// ------------------------------------------------------
// Compute signed angular elements from decimal argument.
// This value is taken as decimal degrees.
   $sign = ($AngDeg < 0)? '-' : '';

   if ($PosSignFlag === TRUE and $sign == '') {$sign = '+';}

   $degrees = abs($AngDeg);
   $dd      = floor($degrees);
   $minutes = 60*($degrees - $dd);
   $mm      = floor($minutes);
   $seconds = 60*($minutes - $mm);
   $ss      = sprintf("%1.3f", $seconds);

// ----------------------------------
// Check for that blasted 60s glitch.
   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $dd++;}

// ----------------------------
// Format the angular elements.
   $dd = sprintf("%02d",  $dd);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%1.$ssDecimals" . "f", $ss);

   if ($ss < 10) {$ss = "0$ss";}

// Attach optional DMS symbols.
// Default = TRUE.
   if ($SymbolsFlag === TRUE)
      {
       $_d_ = "&deg;";
       $_m_ = "'";
       $_s_ = '"';
      }

// Done.
   return "$sign$dd$_d_ $mm$_m_ $ss$_s_";

} // End of  Deg_to_DMS(...)


/*
   ===========================================================================
   Convert hour angle in decimal degrees into hrs, min, sec of RA.
   The angular elements are returned as an HMS or H:M:S string.

   Optional HMS symbols are attached to or colons inserted between the
   elements.  The seconds part can be rounded to up to 3 decimals (0=Default).

   ===========================================================================
*/

   function Deg_to_HMS ($AngDeg, $ssDecimals=0, $PosSignFlag=FALSE, $SymbolsFlag=TRUE)
{

// Init
   $_h_ = $_m_ = $_s_ = '';

// ---------------------------------------------------------
// Compute hour angle elements from signed decimal argument.
// This value is taken as decimal degrees.
   $sign = ($AngDeg < 0)? '-' : '';

   if ($PosSignFlag === TRUE and $sign == '') {$sign = '+';}

   $hours   = abs(trim($AngDeg) / 15);
   $hh      = floor($hours);
   $minutes = 60*($hours - $hh);
   $mm      = floor($minutes);
   $seconds = 60*($minutes - $mm);
   $ss      = sprintf("%1.3f", $seconds);

// ----------------------------------
// Check for that blasted 60s glitch.
   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $hh++;}

// --------------------------------------
// Format and return the angular elements
// in a space-delimited string.
   $hh = sprintf("%02d",  $hh);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%1.$ssDecimals" . "f", $ss);

   if ($ss < 10) {$ss = "0$ss";}

// Attach optional DMS symbols.
// Default = TRUE.
   if ($SymbolsFlag === TRUE)
      {
       $_h_ = 'h';
       $_m_ = "m";
       $_s_ = 's';
      }

// Done.
   return "$sign$hh$_h_ $mm$_m_ $ss$_s_";

} // End of  Deg_to_HMS(...)


// *************************************************************************************

/*

   This function converts decimal hours into
   an hours, minutes and seconds string.

   For example, the arguments (10.123456789, 3)
   hours would return the string "10h 07m 24.444s"

   $SymbolsMode = 0, 1 or 2
                  0 = No symbols
                  1 = Use colons (:) instead of h,m,s symbols = Default
                  2 = Use h,m,s symbols instead of colons.

*/
   function Hours_to_HMS ($hours, $ssDecimals=0, $PosSignFlag=FALSE, $SymbolsMode=1)
{

// ---------------------------
// Initialize symbol carriers.

   $_h_ = $_m_ = $_s_ = '';

// -------------------------------------------------
// Compute time elements from signed hours argument.
// Store and remember sign and work with abs. value.

   $sign = ($hours < 0)? '-' : '';

   if ($PosSignFlag === TRUE and $sign == '') {$sign = '+';}

   $hh      = floor(abs($hours));
   $minutes = 60*(abs($hours) - $hh);
   $mm      = floor($minutes);
   $seconds = 60*($minutes - $mm);
   $ss      = sprintf("%1.3f", $seconds);

// ----------------------------------
// Patch for that blasted 60s glitch.

   if ($ss == 60) {$ss = 0; $mm++;}
   if ($mm == 60) {$mm = 0; $hh++;}

// --------------------------------------
// Format and return the angular elements
// in a space-delimited string.

   $hh = sprintf("%02d",  $hh);
   $mm = sprintf("%02d",  $mm);
   $ss = sprintf("%1.$ssDecimals" . "f", $ss);

   if ($ss < 10) {$ss = "0$ss";}

// ----------------------------------------
// Attach optional h,m,s symbols or colons.
// Default = 1.

   if ($SymbolsMode == 0)
      {
       $_h_ = ' ';
       $_m_ = ' ';
       $_s_ = ' ';
      }

   if ($SymbolsMode == 1)
      {
       $_h_ = ':';
       $_m_ = ':';
       $_s_ =  '';
      }

   if ($SymbolsMode == 2)
      {
       $_h_ = 'h ';
       $_m_ = 'm ';
       $_s_ = 's';
      }


// Done.
   return "$sign$hh$_h_$mm$_m_$ss$_s_";

} // End of  Hours_to_HMS(...)






/*
   This function takes a DMS string and returns the corresponding
   value in decimals degrees.  The DMS elements are delimited by
   spaces.

   Example: Given DMS string = "9 12 50.306"
            Returned = 9.2139738888888889

*/

   function DMS_to_Deg ($DMSstr)
{

// ----------------------------------------------------------
// Read angle/time string argument and force to lower case in
// the event any (deg d h m s : ° ' ") symbols are used.

   $dms = strtolower(trim($DMSstr));

// ------------------------------------------------------
// Convert any (deg d m s ° ' ") symbols into spaces.

   $dms = str_replace('deg', ' ', $dms);
   $dms = str_replace('d',   ' ', $dms);
   $dms = str_replace('m',   ' ', $dms);
   $dms = str_replace('s',   ' ', $dms);
   $dms = str_replace('°',   ' ', $dms);
   $dms = str_replace("'",   ' ', $dms);
   $dms = str_replace('"',   ' ', $dms);

// ----------------------------------------------------
// Normalize the spacing and then split and extract the
// individual angle/time string elements (dh or hh, mm,ss).

   $dms = preg_replace("/\s+/", " ", trim($dms));
   $wdms = preg_split("[ ]", $dms);
   $wdmsCount = count($wdms);
   $dd = ($wdmsCount >= 1)? bcadd($wdms[0],"0", 20) : "0";
   $mm = ($wdmsCount >= 2)? bcadd($wdms[1],"0", 20) : "0";
   $ss = ($wdmsCount >= 3)? bcadd($wdms[2],"0", 20) : "0";

// ------------------------------------------------
// Remember and then remove any numerical (±) sign.

   $NumSign = (substr($DMSstr,0,1) == '-')? '-' : '';
   $dd = str_replace('-', '', $dd);
   $dd = str_replace('+', '', $dd);

// -------------------------------------------------------------
// If original angle argument began with a + sign, then preserve
// it so that all returned positive results will have a + sign.
// Otherwise, positive results will NOT have a + sign.

   if (substr($DMSstr,0,1) == '+') {$NumSign = '+';}

// ----------------------------------------------
// Compute decimal degrees/hours value equivalent
// to the given dhms argument elements.

   $w2 = bcadd(bcadd(bcmul($dd,"3600",20),bcmul($mm,"60",20),20),$ss,20);

// -----------------------------------------------------------
// If result equates to zero, then suppress any numerical sign.

   if (bccomp($w2, "0", 20) == 0) {$NumSign = '';}

// ---------------------------------------------------------
// Round off result to 16 decimals, recalling original sign.

   return $NumSign . bcadd(bcdiv($w2,"3600",20), "0.00000000000000005",16);

} // End of  DMS_to_Deg (...)





/*
   This function takes an HMS string and returns the corresponding
   value in decimals degrees.  The HMS elements are delimited by
   spaces.

   Example: Given HMS string = "10 11 12.246"
            Returned = 9.2139738888888889

*/

   function HMS_to_Deg ($hhmmss)
{

// -----------------------------------------------------------
// Read hour angle string argument and force to lower case in
// the event any (h m s :) symbols are used.

   $hms = strtolower(trim($hhmmss));

// ------------------------------------------------------
// Convert any (h m s :) symbols into spaces.

   $hms = str_replace('h', ' ', $hms);
   $hms = str_replace('m', ' ', $hms);
   $hms = str_replace('s', ' ', $hms);
   $hms = str_replace(':', ' ', $hms);


// ----------------------------------------------------
// Normalize the spacing and then split and extract the
// individual time string elements (hh, mm,ss).

   $hms = preg_replace("/\s+/", " ", trim($hms));
   $whms = preg_split("[ ]", $hms);
   $whmsCount = count($whms);
   $hh = ($whmsCount >= 1)? bcadd($whms[0],"0", 20) : "0";
   $mm = ($whmsCount >= 2)? bcadd($whms[1],"0", 20) : "0";
   $ss = ($whmsCount >= 3)? bcadd($whms[2],"0", 20) : "0";

// ------------------------------------------------
// Remember and then remove any numerical (±) sign.

   $NumSign = (substr($hhmmss,0,1) == '-')? '-' : '';
   $hh = str_replace('-', '', $hh);
   $hh = str_replace('+', '', $hh);

// -------------------------------------------------------------
// If original angle argument began with a + sign, then preserve
// it so that all returned positive results will have a + sign.
// Otherwise, positive results will NOT have a + sign.

   if (substr($hhmmss,0,1) == '+') {$NumSign = '+';}

// --------------------------------------
// Compute decimal hours value equivalent
// to the given hms argument elements.

   $w2 = bcadd(bcadd(bcmul($hh,"3600",20),bcmul($mm,"60",20),20),$ss,20);

// ---------------------------------
// Convert hours value into degrees.

   $w2 = bcmul($w2, '15', 20);

// -----------------------------------------------------------
// If result equates to zero, then suppress any numerical sign.

   if (bccomp($w2, "0", 20) == 0) {$NumSign = '';}

// ---------------------------------------------------------
// Round off result to 16 decimals, recalling original sign.

   return $NumSign . bcadd(bcdiv($w2,"3600",20), "0.00000000000000005",16);

} // End of  HMS_to_Deg(...)





/*
   ========================================================================
   This function performs LaGrange interpolation within an XY data table.

   ========================================================================
*/

   function LaGrange_Interp ($XvsYDataTable, $xArg)
{

// -----------
// Initialize.

   $XDataStr = $YDataStr = '';

// --------------------------------------------------------------
// Read and split XY data pairs into a work array.  In the array,
// even number indices = X-data, odd number indices = Y-data.

   $XY = preg_split("[ ]", preg_replace("/\s+/", ' ', trim($XvsYDataTable)));

// ---------------------------------------------
// Count the total number of data elements. This
// value should always be an even number.

   $TotalDataCount = count($XY);

// ------------------------------------------------------------
// Number of data pairs.  This value should be an integer value
// exactly equal to 1/2 the total number of data points. If not,
// then there is an odd mismatched data point.

   $n = $TotalDataCount / 2;

// -----------------------------------------------------------
// Return error message if data vector element count mismatch.
// For every X value there must be a corresponding Y value or
// an XY data count mismatch error occurs.  An error will also
// occur if insufficient data.  There must be at least two XY
// data points given.

   if ($TotalDataCount < 4 )
      {return "ERROR: There must be at least two XY data pairs.";}

   if ($n != floor($n + 0.5))
      {return "ERROR: XY Data Count Mismatch. Odd data element.";}

// ------------------------------------------------------------
// Compute number of XY data pairs.  This value is exactly half
// the value of the total number of data elements.

   $n = $TotalDataCount / 2;

// -------------------------------------------------------
// Construct separate XY data strings from the array data.
// The XY data strings should each contain the same number
// of data elements.

   for($i=0;   $i < $TotalDataCount;   $i+=2)
      {
       $XDataStr .= $XY[$i]   . " ";
       $YDataStr .= $XY[$i+1] . " ";
      }

// --------------------------------------------------------------
// Split the created XY data vector strings into matching indexed
// arrays.  For every X value there must be a matching Y value
// and no two X values can be identical.

   $X = preg_split("[ ]", trim($XDataStr));
   $Y = preg_split("[ ]", trim($YDataStr));

// ----------------------------------------
// Read X argument for which to interpolate
// the Y value from the given XY data.

   $x = trim($xArg);  if ($x == "") {$x = "0";}

// -----------------------------------
// Initialize Y summation accumulator.
   $y = 0.0;

// -----------------------------------------------------
// Compute LaGrangian product (Li) for given X argument.

   for ($i=0;   $i < $n;   $i++)
       {
        $Li = 1.0;

        for ($j=0;   $j < $n;   $j++)
            {
             if ($j != $i) // Skip this cycle when j == i
                {
                 $Li = ($Li * ($x - $X[$j])) / ($X[$i] - $X[$j]);
                }
            } // Next j

//      --------------------------------------
//      Accumulate sum of Yi polynomial terms.

        $y += ($Y[$i] * $Li);

       } // Next i

   return $y;

} // End of  LaGrange_Interp(...)




/*
   ========================================================================
   This function simply swaps all matching XY data pairs held in a
   space delimited string argument. It was designed as a companion
   to the Lagrange_Interpolate() function to easily facilitate the
   swapping of the XY data computation roles, but it can be used
   for any 2-column data table.

   ERRORS:
   On error FALSE is returned.  An error occurs if
   odd number of data elements or < 4 elements.
   ========================================================================
*/

   function Swap_Data_Columns ($XvsYDataTable)
{

// -------------------------------------------------------------------------
// Read space-delimited data string and split items into a sequential array
// where even indices represent the X-data and odd represents the Y-data.

   $XYData = trim($XvsYDataTable);

// ------------------------------------------------------
// Replace any comma or semicolon delimiters with spaces.

   $XYData = str_replace(";", " ", $XYData);
   $XYData = str_replace(",", " ", $XYData);

// -------------------------------------------------------------------------
// Read space-delimited data string and split items into a sequential array
// where even indices represent the X-data and odd represents the Y-data.

   $XYArray = preg_split("[ ]", preg_replace("/\s+/", " ", trim($XYData)));

   $XYArrayCount = count($XYArray);

   if ($XYArrayCount % 2 != 0 or $XYArrayCount < 4) {return FALSE;}

   $XYPairsCount = $XYArrayCount / 2;

// ------------------------------------------------------
// Construct and return output table of swapped XY pairs.

   $SwappedYvsXDataTable = "";

   for ($i=1;   $i < $XYArrayCount;   $i+=2)
       {
        $SwappedYvsXDataTable .= $XYArray[$i] . " " . $XYArray[$i-1] . "\n";
       }

   return trim($SwappedYvsXDataTable);
}








/*
  ----------------------------------------------------------------------
  This function returns the time of an extremum (minimum or maximum), if
  any, within a given time vs event table.  For example, this function
  can be used to find the times of perihelion, aphelion, perigee, apogee
  or any general periapsis or apoapsis times.  It is based on a 5-point
  data table and the extremum is computed from a polynomial derived from
  the given data.

  ERRORS:
  No error checking is done and the function assumes that an extremum
  exists within the given data table.
  ----------------------------------------------------------------------
*/


   function Extremum5 ($DataTableStr)
{

// ---------------------------------
// Read data table and parse values.
   $DataTable = preg_replace("/\s+/", ' ', trim($DataTableStr));

   list ($x1,$y1, $x2,$y2, $x3,$y3, $x4,$y4, $x5,$y5)
   = preg_split("[ ]", $DataTable);

// Set constant interval between points.
   $interval = $x2 - $x1;

// Compute systematic differentials
   $a = $y2 - $y1;
   $b = $y3 - $y2;
   $c = $y4 - $y3;
   $d = $y5 - $y4;

   $e = $b - $a;
   $f = $c - $b;
   $g = $d - $c;
   $h = $f - $e;
   $i = $g - $f;
   $j = $i - $h;

   $k = $j/24;
   $m = ($h + $i)/12;
   $n = $f/2 - $k;
   $p = ($b + $c)/2 - $m;

   $q = $r = 0;

// Perform extremum zeroing loop for no more than 25 cycles.
   while ($r < 25)
  {
   $s = 6*($b + $c) - $h - $i + 3*$q*$q*($h + $i) + 2*$q*$q*$q*$j;
   $t = $j - 12*$f;
   $q = $s/$t;

   $r++;
  }
   return $q * $interval + $x3; // Done.

} // End of  Extremum5(...)





/*
  ========================================================================
  Level 0

  This function computes the theoretical astronomical delta-T estimate
  in seconds for any dates between -2000 and 3000, based on the NASA
  polymomial expressions for Delta T

  NASA Ref:
  http://eclipse.gsfc.nasa.gov/LEcat5/deltatpoly.html


  ARGUMENTS:
  Y = Year number (-2000 BC to 3000 AD) (Neg=BC)(no year zero)
  mNum = Month number(01 to 12)
  EXAMPLE: Ym = 195005 (= 1950 May)

  ERRORS:
  FALSE is returned on error.  An error results if either
  the year or month number is invalid. A zero year value
  will return an error.
  ========================================================================
*/

   function Delta_T($Ym)
{

// ----------------------------------------------
// ERROR if year value is non-numeric. It must be
// a number in the range from -2000 to +3000.
// Ym = 100*Y + m
   if (!is_numeric(substr($Ym,0,6))) {return FALSE;}

// Parse Ym value.
   $Y = substr($Ym,0,4);
   $mNum = intval(Ltrim(substr($Ym,4,2), '0'));

// ------------------------------------------
// ERROR if year value is invalid. It must be
// in the range from -2000 to +3000.
   if ($Y < -2000 or $Y == 0 or $Y > 3000) {return FALSE;}

// -------------------------------------------------------
// ERROR if month value is outside the range from 1 to 12.
   if ($mNum < 1 or $mNum > 12) {return FALSE;}

// -----------------------------------------------------------
// If a negative (BC) year is given , it is converted into the
// corresponding mathematical year by adding 1.
//
// The year 100 BC (-100), becomes the mathematical year -99.

   $y = $Y + (($Y < 0)? 1:0) + ($mNum - 0.5)/12;


   if ($Y >= -2000 and $Y < -500)
      {
       $u  = ($Y - 1820) / 100;

       return 32*$u*$u - 20;
      }


   if ($Y >= -500 and $Y < 500)
      {
       $u  = $y/100;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;
       $u5 = $u * $u4;
       $u6 = $u * $u5;

       return 10583.6 - 1014.41*$u
                      +   33.78311*$u2
                      -    5.952053*$u3
                      -    0.1798452*$u4
                      +    0.022174192*$u5
                      +    0.0090316521*$u6;
      }


   if ($Y >= 500 and $Y < 1600)
      {
       $u  = ($y - 1000)/100;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;
       $u5 = $u * $u4;
       $u6 = $u * $u5;

       return 1574.2 - 556.01*$u
                     +  71.23472*$u2
                     +   0.319781*$u3
                     -   0.8503463*$u4
                     -   0.005050998*$u5
                     +   0.0083572073*$u6;
      }


   if ($Y >= 1600 and $Y < 1700)
      {
       $u  = $y - 1600;

       return 120 - 0.9808*$u - 0.01532*$u*$u + $u*$u*$u/7129;
      }


   if ($Y >= 1700 and $Y < 1800)
      {
       $u  = $y - 1700;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;

       return 8.83 + 0.1603*$u
                   - 0.0059285*$u2
                   + 0.00013336*$u3
                   - $u4/1174000;
      }


   if ($Y >= 1800 and $Y < 1860)
      {
       $u  = $y - 1800;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;
       $u5 = $u * $u4;
       $u6 = $u * $u5;
       $u7 = $u * $u6;

       return 13.72 - 0.332447*$u
                    + 0.0068612*$u2
                    + 0.0041116*$u3
                    - 0.00037436*$u4
                    + 0.0000121272*$u5
                    - 0.0000001699*$u6
                    + 0.000000000875*$u7;
      }


   if ($Y >= 1860 and $Y < 1900)
      {
       $u  = $y - 1860;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;
       $u5 = $u * $u4;

       return 7.62 + 0.5737*$u
                   - 0.251754*$u2
                   + 0.01680668*$u3
                   - 0.0004473624*$u4
                   + $u5 / 233174;
      }


   if ($Y >= 1900 and $Y < 1920)
      {
       $u  = $y - 1900;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;

       return 1.494119*$u - 2.79
                          - 0.0598939*$u2
                          + 0.0061966*$u3
                          - 0.000197*$u4;
      }


   if ($Y >= 1920 and $Y < 1941)
      {
       $u  = $y - 1920;
       $u2 = $u * $u;
       $u3 = $u * $u2;

       return 21.20 + 0.84493*$u - 0.076100*$u2 + 0.0020936*$u3;
      }


   if ($Y >= 1941 and $Y < 1961)
      {
       $u  = $y - 1950;
       $u2 = $u * $u;
       $u3 = $u * $u2;

       return 29.07 + 0.407*$u - $u2/233 + $u3/2547;
      }


   if ($Y >= 1961 and $Y < 1986)
      {
       $u = $y - 1975;
       $u2 = $u * $u;
       $u3 = $u * $u2;

       return 45.45 + 1.067*$u - $u2/260 - $u3/718;
      }


   if ($Y >= 1986 and $Y < 2005)
      {
       $u  = $y - 2000;
       $u2 = $u * $u;
       $u3 = $u * $u2;
       $u4 = $u * $u3;
       $u5 = $u * $u4;

       return 63.86 + 0.3345*$u
                    - 0.060374*$u2
                    + 0.0017275*$u3
                    + 0.000651814*$u4
                    + 0.00002373599*$u5;
      }


   if ($Y >= 2005 and $Y < 2050)
      {
       $u  = $y - 2000;

       return 62.92 + 0.32217*$u + 0.005589*$u*$u;
      }


   if ($Y >= 2050 and $Y <= 2150)
      {
       $u  = ($y - 1820) / 100;

       return 32*$u*$u - 0.5628*(2150 - $y) - 20;
      }


   if ($Y > 2150 and $Y <= 3000)
      {
       $u  = ($y - 1820) / 100;

       return 32*$u*$u - 20;
      }

   return FALSE;

} // End of  Delta_T(...)




/*
   ========================================================================
   LEVEL-1 FUNCTIONS:

   FUNCTIONS BELOW ARE LEVEL-1 FUNCTIONS, MEANING THAT THEY CALL AT LEAST 1
   OR MORE LEVEL-0 FUNCTIONS ABOVE.  THEY CANNOT BE TRANSPORTED WITHOUT
   ALSO INCLUDING THE LEVEL-0 FUNCTIONS THEY DEPEND ON AS WELL.
   ========================================================================
*/







/*
   This function computes the nutation in right ascension or the equation
   of the equinoxes, in degrees.

   This value is the difference (True Equinox) minus (Mean Equinox).

   The IAU 2000B nutation series is applied.

   LEVEL 0 DEPENDENCIES:
   Mean_Eps()
   dEps()
   dPsi()


   NOTE:
   Degrees * 240 = Seconds of RA
   ========================================================================
*/

   function dEquinox_2000B($JDTT)
{

// ---------------------------------------------
// Compute cosine of true obliquity of ecliptic.

   $CosEpsTrue = cos(deg2rad(Mean_Eps($JDTT) + dEps_2000B($JDTT)));

// --------------------------------------------
// Return equation of the equinoxes in degrees.

   return dPsi_2000B($JDTT) * $CosEpsTrue;

} // End of  dEquinox()







/*
   This function takes an HMS string and returns the corresponding
   value in decimals hours.  The HMS elements are delimited by
   spaces.

   Example: Given HMS string = "10 11 12.246"
            Returned = 10.

*/

   function HMS_to_Hours ($hhmmss)
{

// -----------------------------------------------------------
// Read hour angle string argument and force to lower case in
// the event any (h m s :) symbols are used.

   $hms = strtolower(trim($hhmmss));

// ------------------------------------------------------
// Convert any (h m s :) symbols into spaces.

   $hms = str_replace('h', ' ', $hms);
   $hms = str_replace('m', ' ', $hms);
   $hms = str_replace('s', ' ', $hms);
   $hms = str_replace(':', ' ', $hms);


// ----------------------------------------------------
// Normalize the spacing and then split and extract the
// individual time string elements (hh, mm,ss).

   $hms = preg_replace("/\s+/", " ", trim($hms));
   $whms = preg_split("[ ]", $hms);
   $whmsCount = count($whms);
   $hh = ($whmsCount >= 1)? bcadd($whms[0],"0", 20) : "0";
   $mm = ($whmsCount >= 2)? bcadd($whms[1],"0", 20) : "0";
   $ss = ($whmsCount >= 3)? bcadd($whms[2],"0", 20) : "0";

// ------------------------------------------------
// Remember and then remove any numerical (±) sign.

   $NumSign = (substr($hhmmss,0,1) == '-')? '-' : '';
   $hh = str_replace('-', '', $hh);
   $hh = str_replace('+', '', $hh);

// -------------------------------------------------------------
// If original angle argument began with a + sign, then preserve
// it so that all returned positive results will have a + sign.
// Otherwise, positive results will NOT have a + sign.

   if (substr($hhmmss,0,1) == '+') {$NumSign = '+';}

// --------------------------------------
// Compute decimal hours value equivalent
// to the combined h,m,s values.

   $w2 = bcadd(bcadd(bcmul($hh,"3600",20),bcmul($mm,"60",20),20),$ss,20);

// ------------------------------------------------------------
// If result equates to zero, then suppress any numerical sign.

   if (bccomp($w2, "0", 20) == 0) {$NumSign = '';}

// ---------------------------------------------------------
// Round off result to 16 decimals, recalling original sign.

   return $NumSign . bcadd(bcdiv($w2,3600, 20), "0.00000000000000005", 16);

} // End of  HMS_to_Hours(...)



   function xxx_360_24 ($AngleTableString, $adj=360)
{
// Convert (\n) codes into spaces and then remove any redundant white space.
   $AngTableStr = preg_replace("/\s\s+/", " ", trim(preg_replace("[\n]"," ", $AngleTableString)));

// Put paired space-delimited elements into array.
   $wArray = preg_split("[ ]", $AngTableStr);

// Count total array elements.  Should always be an even
// number, since it equates to two times the number of
// data pairs.  The odd indexed elements are the angle
// values and the even indexed elements are the JD12TT
// values.
   $wArrayCount = count($wArray);

// Get first and final angle values from array.
   $FirstAng = substr($wArray[1], -9);
   $FinalAng = substr($wArray[$wArrayCount-1], -9);

// Cycle through array, adding adjustment to all the
// angles that have values < first angle value.
   $AngTableStr = "";
   for($i=1;   $i <= $wArrayCount;   $i+=2)
      {
       $wArray[$i]  += (($wArray[$i] < $FirstAng)? $adj:0);
       $AngTableStr .= ($wArray[$i-1] . " " . $wArray[$i] . "\n");
      }

// Done.
   return trim($AngTableStr);
}





/*
   This function computes the local azimuth (direction) and
   altitude relative to the local horizon, in degrees.

   JDTT    = Astronomical JD argument corresponding to date/time
   RAHrs   = Right Ascension of body, in HOURS - not degrees.
   DeclDeg = Declination of body, from 0 to ±90 degrees.

   Output  = Horizon coordinates string = "AzimDeg DeclDeg"
   AzimDeg = Azimuth (Direction) from 0 to 360° (North = 0°/360°).
   AltDeg  = Altitude relative to horizon (Neg = Below horizon).
*/

   function Azim_Alt ($JDTT, $RAHrs, $DeclDeg)
{
// Get external global geographic location variables.
   global $LngDeg, $LatDeg;

// Compute local true sidereal time.
   $LSTTrueDeg = Mean_Sid_Time($JDTT, $LngDeg) + dEquinox_2000B($JDTT);

// Compute local hour angle of body.
   $H = $LSTTrueDeg - $RAHrs*15;

// Compute azimuth clockwise from 0 to 360 degrees (North = 0 degrees).
   $AzimDeg = 180 + atan2_d(sin_d($H), (cos_d($H)*sin_d($LatDeg) - tan_d($DeclDeg)*cos_d($LatDeg)));
   $AzimDeg -= (($AzimDeg >= 360)? 360:0);

// Compute altitude relative to local horizon.  Negative = Below horizon.
   $SinAlt = sin_d($LatDeg)*sin_d($DeclDeg) + cos_d($LatDeg)*cos_d($DeclDeg)*cos_d($H);
   $AltDeg = asin_d($SinAlt);

   return "$AzimDeg $AltDeg";
}




/*
   ========================================================================
   This function returns the compass symbol corresponding to
   azimuth angle in degrees and zero-mode.  The default zero
   azimuth direction is north.

   ZeroModeSymbol = 'N' (North = 0 convention = Default)
   ZeroModeSymbol = 'S' (South = 0 convention = Optional)

   ========================================================================
*/

   function Compass_Symbol ($AzimDeg, $ZeroModeSymbol='N')
{
   $a = floatval($AzimDeg) + ((strtoupper($ZeroModeSymbol) == 'S')? 180:0);

   $a -= 360*floor($a/360);

   $i = ($a < 11.25 or $a > 348.75)? 0 : floor(0.5 + $a/22.5);

   if ($ZeroModeSymbol != 'S')
   {return trim(substr("N  NNENE ENEE  ESESE SSES  SSWSW WSWW  WNWNW NNWN", 3*$i, 3));}
   else
   {return trim(substr("S  SSWSW WSWW  WNWNW NNWN  NNENE ENEE  ESESE SSES", 3*$i, 3));}
}




   function LZPad_Number($NumberVal, $NumPaddingZeros=0)
{
   $dp = strpos($NumberVal, ".");

   if ($dP === FALSE)
      {
       return sprintf("%0$nz", $NumberVal);
      }
   else
      {
       $i = sprintf("%0$nz", substr($NumberVal, 0, $dp-1));
       $d = substr($NumberVal, $dp, strlen($NumberVal));
       return "$i$d";
      }
}



?>

